clear all;

% Add caffe/matlab to you Matlab search PATH to use matcaffe
addpath('/home/vtu/caffem/matlab/caffe');

% Add tsne/bhtsne to your Matlab search PATH to use bhtsne
addpath('/home/vtu/tsne/bhtsne');

% Change here parameters for visualization
use_gpu = 0; %-- we will be using CPU mode, change to 1 - for GPU mode

expath = '/home/vtu/caffem/VTU/02cae/mnist10sym02publish/VisInsideCAE/';
model_file = 'mnistCAE10sym0210-02_iter_20000.caffemodel';

model_def_file01 = '01mnistCAE10sym0210conv1.prototxt';
model_def_file02 = '02mnistCAE10sym0210sig1en.prototxt';
model_def_file03 = '03mnistCAE10sym0210conv2.prototxt';
model_def_file04 = '04mnistCAE10sym0210sig2en.prototxt';
model_def_file05 = '05mnistCAE10sym0210ip1encode.prototxt';
model_def_file06 = '06mnistCAE10sym0210sig3en.prototxt';
model_def_file07 = '07mnistCAE10sym0210ip2encode.prototxt';
model_def_file08 = '08mnistCAE10sym0210ip1decode.prototxt';
model_def_file09 = '09mnistCAE10sym0210sig3de.prototxt';
model_def_file10 = '10mnistCAE10sym0210deconv2.prototxt';
model_def_file11 = '11mnistCAE10sym0210sig2de.prototxt';
model_def_file12 = '12mnistCAE10sym0210deconv1.prototxt';
model_def_file13 = '13mnistCAE10sym0210sig1de.prototxt';
model_def_file14 = '14mnistCAE10sym0210deconv1neur.prototxt';
model_def_file15 = '15mnistCAE10sym0210deconv1neursig.prototxt';

TestFileMAT = '/home/vtu/caffe/data/mnistmat/mnist_test.mat';

% Prepare input data
heightW = 28;
widthW = 28;
TE = 10000;

caffein = zeros(heightW, widthW, 1, TE, 'single');
load(TestFileMAT);

for j=1:TE
    for i=1:heightW for k=1:widthW caffein(i, k, 1, j) = test_X(j, k+(i-1)*widthW); end; end
end

% Call Caffe to have outputs for all layers

% 1 layer - conv1 - 20, 20, 8, j
matcaffe_init(use_gpu, strcat(expath, model_def_file01), strcat(expath, model_file));
conv1 = caffe('forward', {caffein});
conv1 = conv1{1};
caffe('reset');

% 2 layer - sig1en - 20, 20, 8, j
matcaffe_init(use_gpu, strcat(expath, model_def_file02), strcat(expath, model_file));
sig1en = caffe('forward', {caffein});
sig1en = sig1en{1};
caffe('reset');

% 3 layer - conv2 - 12, 12, 4, j
matcaffe_init(use_gpu, strcat(expath, model_def_file03), strcat(expath, model_file));
conv2 = caffe('forward', {caffein});
conv2 = conv2{1};
caffe('reset');

% 4 layer - sig2en - 12, 12, 4, j
matcaffe_init(use_gpu, strcat(expath, model_def_file04), strcat(expath, model_file));
sig2en = caffe('forward', {caffein});
sig2en = sig2en{1};
caffe('reset');

% 5 layer - ip1encode - 1, 1, 250, j
matcaffe_init(use_gpu, strcat(expath, model_def_file05), strcat(expath, model_file));
ip1encode = caffe('forward', {caffein});
ip1encode = ip1encode{1};
caffe('reset');

% 6 layer - sig3en - 1, 1, 250, j
matcaffe_init(use_gpu, strcat(expath, model_def_file06), strcat(expath, model_file));
sig3en = caffe('forward', {caffein});
sig3en = sig3en{1};
caffe('reset');

% 7 layer - ip2encode - 1, 1, 10, j
matcaffe_init(use_gpu, strcat(expath, model_def_file07), strcat(expath, model_file));
ip2encode = caffe('forward', {caffein});
ip2encode = ip2encode{1};
caffe('reset');

% 8 layer - ip1decode - 1, 1, 250, j
matcaffe_init(use_gpu, strcat(expath, model_def_file08), strcat(expath, model_file));
ip1decode = caffe('forward', {caffein});
ip1decode = ip1decode{1};
caffe('reset');

% 9 layer - sig3de - 1, 1, 250, j
matcaffe_init(use_gpu, strcat(expath, model_def_file09), strcat(expath, model_file));
sig3de = caffe('forward', {caffein});
sig3de = sig3de{1};
caffe('reset');

% 10 layer - deconv2 - 12, 12, 4, j
matcaffe_init(use_gpu, strcat(expath, model_def_file10), strcat(expath, model_file));
deconv2 = caffe('forward', {caffein});
deconv2 = deconv2{1};
caffe('reset');

% 11 layer - sig2de - 12, 12, 4, j
matcaffe_init(use_gpu, strcat(expath, model_def_file11), strcat(expath, model_file));
sig2de = caffe('forward', {caffein});
sig2de = sig2de{1};
caffe('reset');

% 12 layer - deconv1 - 28, 28, 4, j
matcaffe_init(use_gpu, strcat(expath, model_def_file12), strcat(expath, model_file));
deconv1 = caffe('forward', {caffein});
deconv1 = deconv1{1};
caffe('reset');

% 13 layer - sig1de - 28, 28, 4, j
matcaffe_init(use_gpu, strcat(expath, model_def_file13), strcat(expath, model_file));
sig1de = caffe('forward', {caffein});
sig1de = sig1de{1};
caffe('reset');

% 14 layer - deconv1neur - 28, 28, 1, j
matcaffe_init(use_gpu, strcat(expath, model_def_file14), strcat(expath, model_file));
deconv1neur = caffe('forward', {caffein});
deconv1neur = deconv1neur{1};
caffe('reset');

% 15 layer - deconv1neursig - 28, 28, 1, j
matcaffe_init(use_gpu, strcat(expath, model_def_file15), strcat(expath, model_file));
deconv1neursig = caffe('forward', {caffein});
deconv1neursig = deconv1neursig{1};
caffe('reset');

% Start visualization first 10 digits from MNIST test file - their indexes below
VisInd = [1, 1820, 3050, 3830, 4510, 5400, 6350, 8000, 8680, 9580];

for j=1:10
	% visualize input image
	ImVis = caffein(:, :, 1, VisInd(j));
	figure;
	imagesc(ImVis);
	title(strcat(int2str(test_labels(VisInd(j))), '-00-Original image'));
	saveas(gcf, strcat(int2str(test_labels(VisInd(j))), '-00-Original image', '.png'));

	% visualize 1 layer - conv1 - 20, 20, 8, j
	figure;
	for NumIm=1:8
 		ImVis = conv1(:, :, NumIm, VisInd(j));
		subplot(2, 4, NumIm), imagesc(ImVis), axis off;
	end
	MinVal = min(min(min(conv1(:, :, :, VisInd(j)))));
	MaxVal = max(max(max(conv1(:, :, :, VisInd(j)))));
	set(gcf,'NextPlot','add'); axes;
	hT = title(strcat(int2str(test_labels(VisInd(j))), '-01-20x20x8 Conv1', '-[', num2str(MinVal,4), '..', num2str(MaxVal,4), ']'));
	set(gca,'Visible','off'); set(hT,'Visible','on'); 
	saveas(gcf, strcat(int2str(test_labels(VisInd(j))), '-01-20x20x8 Conv1', '.png'));

	% visualize 2 layer - sig1en - 20, 20, 8, j
	figure;
	for NumIm=1:8
 		ImVis = sig1en(:, :, NumIm, VisInd(j));
		subplot(2, 4, NumIm), imagesc(ImVis), axis off;
	end
	MinVal = min(min(min(sig1en(:, :, :, VisInd(j)))));
	MaxVal = max(max(max(sig1en(:, :, :, VisInd(j)))));
	set(gcf,'NextPlot','add'); axes;
	hT = title(strcat(int2str(test_labels(VisInd(j))), '-02-20x20x8 Sig1en', '-[', num2str(MinVal,4), '..', num2str(MaxVal,4), ']'));
	set(gca,'Visible','off'); set(hT,'Visible','on'); 
	saveas(gcf, strcat(int2str(test_labels(VisInd(j))), '-02-20x20x8 Sig1en', '.png'));

	% visualize 3 layer - conv2 - 12, 12, 4, j
	figure;
	for NumIm=1:4
 		ImVis = conv2(:, :, NumIm, VisInd(j));
		subplot(2, 2, NumIm), imagesc(ImVis), axis off;
	end
	MinVal = min(min(min(conv2(:, :, :, VisInd(j)))));
	MaxVal = max(max(max(conv2(:, :, :, VisInd(j)))));
	set(gcf,'NextPlot','add'); axes;
	hT = title(strcat(int2str(test_labels(VisInd(j))), '-03-12x12x4 Conv2', '-[', num2str(MinVal,4), '..', num2str(MaxVal,4), ']'));
	set(gca,'Visible','off'); set(hT,'Visible','on'); 
	saveas(gcf, strcat(int2str(test_labels(VisInd(j))), '-03-12x12x4 Conv2', '.png'));

	% visualize 4 layer - sig2en - 12, 12, 4, j
	figure;
	for NumIm=1:4
 		ImVis = sig2en(:, :, NumIm, VisInd(j));
		subplot(2, 2, NumIm), imagesc(ImVis), axis off;
	end
	MinVal = min(min(min(sig2en(:, :, :, VisInd(j)))));
	MaxVal = max(max(max(sig2en(:, :, :, VisInd(j)))));
	set(gcf,'NextPlot','add'); axes;
	hT = title(strcat(int2str(test_labels(VisInd(j))), '-04-12x12x4 Sig2en', '-[', num2str(MinVal,4), '..', num2str(MaxVal,4), ']'));
	set(gca,'Visible','off'); set(hT,'Visible','on'); 
	saveas(gcf, strcat(int2str(test_labels(VisInd(j))), '-04-12x12x4 Sig2en', '.png'));

	% visualize 5 layer - ip1encode - 1, 1, 250, j
	figure;
	ImVis = squeeze(ip1encode(1, 1, :, VisInd(j)));
	bar(ImVis); xlim([1 250]);
	title(strcat(int2str(test_labels(VisInd(j))), '-05-1x1x250 Ip1encode'));
	saveas(gcf, strcat(int2str(test_labels(VisInd(j))), '-05-1x1x250 Ip1encode', '.png'));

	% visualize 6 layer - sig3en - 1, 1, 250, j
	figure;
	ImVis = squeeze(sig3en(1, 1, :, VisInd(j)));
	bar(ImVis); xlim([1 250]);
	title(strcat(int2str(test_labels(VisInd(j))), '-06-1x1x250 Sig3en'));
	saveas(gcf, strcat(int2str(test_labels(VisInd(j))), '-06-1x1x250 Sig3en', '.png'));

	% visualize 7 layer - ip2encode - 1, 1, 10, j
	figure;
	ImVis = squeeze(ip2encode(1, 1, :, VisInd(j)));
	bar(ImVis); xlim([1 10]);
	title(strcat(int2str(test_labels(VisInd(j))), '-07-1x1x10 Ip2encode'));
	saveas(gcf, strcat(int2str(test_labels(VisInd(j))), '-07-1x1x10 Ip2encode', '.png'));

	% visualize 8 layer - ip1decode - 1, 1, 250, j
	figure;
	ImVis = squeeze(ip1decode(1, 1, :, VisInd(j)));
	bar(ImVis); xlim([1 250]);
	title(strcat(int2str(test_labels(VisInd(j))), '-08-1x1x250 Ip1decode'));
	saveas(gcf, strcat(int2str(test_labels(VisInd(j))), '-08-1x1x250 Ip1decode', '.png'));

	% visualize 9 layer - sig3de - 1, 1, 250, j
	figure;
	ImVis = squeeze(sig3de(1, 1, :, VisInd(j)));
	bar(ImVis); xlim([1 250]);
	title(strcat(int2str(test_labels(VisInd(j))), '-09-1x1x250 Sig3de'));
	saveas(gcf, strcat(int2str(test_labels(VisInd(j))), '-09-1x1x250 Sig3de', '.png'));

	% visualize 10 layer - deconv2 - 12, 12, 4, j
	figure;
	for NumIm=1:4
 		ImVis = deconv2(:, :, NumIm, VisInd(j));
		subplot(2, 2, NumIm), imagesc(ImVis), axis off;
	end
	MinVal = min(min(min(deconv2(:, :, :, VisInd(j)))));
	MaxVal = max(max(max(deconv2(:, :, :, VisInd(j)))));
	set(gcf,'NextPlot','add'); axes;
	hT = title(strcat(int2str(test_labels(VisInd(j))), '-10-12x12x4 Deconv2', '-[', num2str(MinVal,4), '..', num2str(MaxVal,4), ']'));
	set(gca,'Visible','off'); set(hT,'Visible','on'); 
	saveas(gcf, strcat(int2str(test_labels(VisInd(j))), '-10-12x12x4 Deconv2', '.png'));

	% visualize 11 layer - sig2de - 12, 12, 4, j
	figure;
	for NumIm=1:4
 		ImVis = sig2de(:, :, NumIm, VisInd(j));
		subplot(2, 2, NumIm), imagesc(ImVis), axis off;
	end
	MinVal = min(min(min(sig2de(:, :, :, VisInd(j)))));
	MaxVal = max(max(max(sig2de(:, :, :, VisInd(j)))));
	set(gcf,'NextPlot','add'); axes;
	hT = title(strcat(int2str(test_labels(VisInd(j))), '-11-12x12x4 Sig2de', '-[', num2str(MinVal,4), '..', num2str(MaxVal,4), ']'));
	set(gca,'Visible','off'); set(hT,'Visible','on'); 
	saveas(gcf, strcat(int2str(test_labels(VisInd(j))), '-11-12x12x4 Sig2de', '.png'));

	% visualize 12 layer - deconv1 - 28, 28, 4, j
	figure;
	for NumIm=1:4
 		ImVis = deconv1(:, :, NumIm, VisInd(j));
		subplot(2, 2, NumIm), imagesc(ImVis), axis off;
	end
	MinVal = min(min(min(deconv1(:, :, :, VisInd(j)))));
	MaxVal = max(max(max(deconv1(:, :, :, VisInd(j)))));
	set(gcf,'NextPlot','add'); axes;
	hT = title(strcat(int2str(test_labels(VisInd(j))), '-12-28x28x4 Deconv1', '-[', num2str(MinVal,4), '..', num2str(MaxVal,4), ']'));
	set(gca,'Visible','off'); set(hT,'Visible','on'); 
	saveas(gcf, strcat(int2str(test_labels(VisInd(j))), '-12-28x28x4 Deconv1', '.png'));

	% visualize 13 layer - sig1de - 28, 28, 4, j
	figure;
	for NumIm=1:4
 		ImVis = sig1de(:, :, NumIm, VisInd(j));
		subplot(2, 2, NumIm), imagesc(ImVis), axis off;
	end
	MinVal = min(min(min(sig1de(:, :, :, VisInd(j)))));
	MaxVal = max(max(max(sig1de(:, :, :, VisInd(j)))));
	set(gcf,'NextPlot','add'); axes;
	hT = title(strcat(int2str(test_labels(VisInd(j))), '-13-28x28x4 Sig1de', '-[', num2str(MinVal,4), '..', num2str(MaxVal,4), ']'));
	set(gca,'Visible','off'); set(hT,'Visible','on'); 
	saveas(gcf, strcat(int2str(test_labels(VisInd(j))), '-13-28x28x4 Sig1de', '.png'));

	% visualize 14 layer - deconv1neur - 28, 28, 1, j
	figure;
	ImVis = deconv1neur(:, :, 1, VisInd(j));
	MinVal = min(min(min(deconv1neur(:, :, :, VisInd(j)))));
	MaxVal = max(max(max(deconv1neur(:, :, :, VisInd(j)))));
	imagesc(ImVis);
	title(strcat(int2str(test_labels(VisInd(j))), '-14-28x28x1 Deconv1neur', '-[', num2str(MinVal,4), '..', num2str(MaxVal,4), ']'));
	saveas(gcf, strcat(int2str(test_labels(VisInd(j))), '-14-28x28x1 Deconv1neur', '.png'));

	% visualize 15 layer - deconv1neursig - 28, 28, 1, j
	figure;
	ImVis = deconv1neursig(:, :, 1, VisInd(j));
	MinVal = min(min(min(deconv1neursig(:, :, :, VisInd(j)))));
	MaxVal = max(max(max(deconv1neursig(:, :, :, VisInd(j)))));
	imagesc(ImVis);
	title(strcat(int2str(test_labels(VisInd(j))), '-15-28x28x1 Deconv1neursig', '-[', num2str(MinVal,4), '..', num2str(MaxVal,4), ']'));
	saveas(gcf, strcat(int2str(test_labels(VisInd(j))), '-15-28x28x1 Deconv1neursig', '.png'));
end

% At the end - visualize two main components for whole experiment

% Work with t-SNE
% We will be using 10 initial dimensions because we have 10 CAE outputs
% and we eliminate PCA - the first stage of the t-SNE algorithm

pc10 = (squeeze(ip2encode)');
diary(strcat(model_file, '.tsne', '.log'));
no_dims = 2;
initial_dims = 10;
pc2 = fast_tsne(pc10, no_dims, initial_dims);

figure;
gscatter(pc2(:,1), pc2(:,2), test_labels), grid on;
title(model_file);
xlabel('1st dimension');
ylabel('2nd dimension');
saveas(gcf, strcat(model_file, '.png'));
save mnistCAE10sym02vis1002;
diary('off');