clear all;

% Add caffe/matlab to you Matlab search PATH to use matcaffe
addpath('/home/vtu/caffem/matlab/caffe');

% Change here parameters for visualization
use_gpu = 0; %-- we will be using CPU mode, change to 1 - for GPU mode

expath = '/home/vtu/caffem/VTU/02cae/mnist10sym02/';
model_def_file = 'mnistCAE10sym0202.prototxt';
model_file = 'mnistCAE10sym0202-03_iter_19000.caffemodel';
TestFileMAT = '/home/vtu/caffe/data/mnistmat/mnist_test.mat';

% Prepare input data
heightW = 28;
widthW = 28;
TE = 10000;

caffein = zeros(heightW, widthW, 1, TE, 'single');
load(TestFileMAT);

for j=1:TE
    for i=1:heightW for k=1:widthW caffein(i, k, 1, j) = test_X(j, k+(i-1)*widthW); end; end
end

% Work with caffe 
matcaffe_init(use_gpu, strcat(expath, model_def_file), strcat(expath, model_file));
pc2 = caffe('forward', {caffein});
pc2 = pc2{1};
caffe('reset');
pc2 = (squeeze(pc2)');

figure;
gscatter(pc2(:,1), pc2(:,2), test_labels), grid on;
title('Model 2, 2 hidden output neurons');
xlabel('1st dimension');
ylabel('2nd dimension');
saveas(gcf, strcat(model_file, '.Fig1', '.png'));